using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace BackGroundThread
{
	public partial class FormMain : Form
	{


		private TestData _td;
		public FormMain()
		{
			InitializeComponent();
		}

		private void button3_Click(object sender, EventArgs e)
		{
			this.Close();
		}

		private void FormMain_Load(object sender, EventArgs e)
		{
			Utils.init();
		}

		private void button1_Click(object sender, EventArgs e)
		{
			this.listBox1.Items.Clear();
			for (int i = 0; i < 1024; i++)
			{
				this.listBox1.Items.Add(Utils.al[i]);
				this.listBox1.Update();
			}
		}



		private void button2_Click(object sender, EventArgs e)
		{
			this.listBox1.Items.Clear();
			BackGround bg = new BackGround();
			System.Threading.Thread t = new System.Threading.Thread(new System.Threading.ThreadStart(bg.ProcessData));
			bg.MyAddListItemEvent += new AddListItem(AddListItemMethod);
			t.Start();
		}
		public void UpdateList(object sender, EventArgs e)
		{
			this.listBox1.Items.Add(this._td);
			this.listBox1.Update();
		}

		private void AddListItemMethod(TestData td)
		{
			this._td = td;
			this.listBox1.Invoke(new System.EventHandler(UpdateList));
			//this.listBox1.Items.Add(td);
		}


		private void button4_Click(object sender, EventArgs e)
		{
			this.listBox1.Items.Clear();
			BackGround bg = new BackGround();
			System.Threading.Thread t = new System.Threading.Thread(new System.Threading.ThreadStart(bg.ProcessData));
			bg.MyAddListItemEvent += new AddListItem(AddListItemMethod2);
			this.myUpdateList2 = new UpdateList2(this.UpdateListMethod2);
			t.Start();
		}
		private delegate void UpdateList2(TestData td);
		private UpdateList2 myUpdateList2;
		private void UpdateListMethod2(TestData td)
		{
			this.listBox1.Items.Add(td);
			this.listBox1.Update();
		}
		private void AddListItemMethod2(TestData td)
		{
			this.listBox1.Invoke(this.myUpdateList2, new object[] { td });
		}
	}
	public class TestData
	{
		private int _Data;
		private int _ID;
		public TestData(int id, int data)
		{
			_ID = id;
			_Data = data;
		}
		public int ID
		{
			get { return _ID; }
			set { _ID = value; }
		}
		public int Data
		{
			get { return _Data; }
			set { _Data = value; }
		}
		public override string ToString()
		{
			return _Data.ToString();
		}
	}
}