using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;
namespace XMLLoad
{
	public partial class FormMain : Form
	{
		public FormMain()
		{
			InitializeComponent();
		}

		private void button3_Click(object sender, EventArgs e)
		{
			this.Close();
		}

		private string GetFilePath()
		{
			string text1;
			text1 = Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetName().CodeBase);
			text1 = Path.Combine(text1, "Data.xml");
			return text1;
		}

		private void button1_Click(object sender, EventArgs e)
		{
			System.Xml.XmlDocument doc = new System.Xml.XmlDocument();
			int start, go, end, load, read;
			
			start = System.Environment.TickCount;
			doc.Load(GetFilePath());
			
			go = System.Environment.TickCount;
			load = go - start;

			this.TraverseChildren(doc.DocumentElement);
			end = System.Environment.TickCount;
			read = end - go;
			this.label1.Text = load.ToString() + "," + read.ToString();
			

		}
		private void TraverseChildren(System.Xml.XmlNode parentNode)
		{
			for (int i = 0; i < parentNode.ChildNodes.Count; i++)
			{
				TraverseChildren(parentNode.ChildNodes[i]);
			}
		}

		private void button2_Click(object sender, EventArgs e)
		{
			System.Xml.XmlTextReader reader;
			int start, go, end, load, read;
			
			start = System.Environment.TickCount;
			reader = new System.Xml.XmlTextReader(GetFilePath());
			go = System.Environment.TickCount;
			load = go - start;

			while (reader.Read())
			{

			}
			end = System.Environment.TickCount;
			read = end - go;
			this.label2.Text = load.ToString() + "," + read.ToString();
		}

	}
}